%define gcj_support             1
%define major                   4
%define minor                   0       
%define patch                   5       
%define majmin                  %{major}.%{minor}
%define eclipse_base            %{_libdir}/eclipse

Name:           eclipse-photran
Version:        %{majmin}.%{patch}
Release:        0.1.v20090801%{?dist}
Summary:        Eclipse Fortran Development Tools (Photran) plugin

Group:          Development/Tools
License:        EPL
URL:            http://www.eclipse.org/photran
# The following tarball was generated by the makesource.sh script
Source0:        photran-v20090801-LastBeforePhotran50.tar.gz
Source1:        makesource.sh
Source2:        cdtdb-4.0.3-eclipse.jar
Source3:        vpg-eclipse.jar
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 

# Currently, upstream CDT only supports building on the platforms listed here.
ExclusiveArch: %{ix86} x86_64 ppc ia64

BuildRequires:  eclipse-pde
BuildRequires:  eclipse-cdt >= 1:5.0
%if %{gcj_support}
BuildRequires:  gcc-java >= 4.0.2
BuildRequires:  java-gcj-compat-devel >= 1.0.64
Requires(post):   java-gcj-compat >= 1.0.64
Requires(postun): java-gcj-compat >= 1.0.64
%else
BuildRequires:  java-devel >= 1.4.2
%endif

Requires:       eclipse-cdt >= 1:5.0
Requires:       gdb make gcc-gfortran


%description
The eclipse-photran package contains the Photran Eclipse feature and plugins
that are useful for Fortran development.


%package        intel
Summary:        Intel Fortran compiler support for Photran
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    intel
%{summary}.


%package        xlf
Summary:        IBM XL Fortran compiler support for Photran
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    xlf
%{summary}.


%prep
%setup -q -n photran-v20090801-LastBeforePhotran50 -a 2 -a 3
# Fixup to use 1.5 source level
find -name \*.prefs | xargs sed -i -e 's/source=1.3/source=1.5/'
# This prevents the intel feature from building
sed -i -e 's/os="linux"//' org.eclipse.photran.intel-feature/feature.xml


%build
export JAVA_HOME=%{java_home}
export PATH=%{java_bin}:/usr/bin:$PATH
# Build the helper jars first
pushd cdtdb-4.0.3-eclipse
classpath=$(echo %{_libdir}/eclipse/plugins/org.eclipse.equinox.common_*.jar | sed -e 's/ /:/g')
find -name \*java -exec javac -classpath $classpath '{}' + 
jar cf ../org.eclipse.photran.core.vpg/cdtdb-4.0.3-eclipse.jar *
popd
#Interferes with feature build
rm -rf cdtdb-4.0.3-eclipse

pushd vpg-eclipse
classpath=$(echo %{_libdir}/eclipse/plugins/org.eclipse.equinox.common_*.jar %{_libdir}/eclipse/plugins/org.eclipse.core.jobs_*.jar %{_libdir}/eclipse/plugins/org.eclipse.core.resources_*.jar %{_libdir}/eclipse/plugins/org.eclipse.core.runtime_*.jar ../org.eclipse.photran.core.vpg/cdtdb-4.0.3-eclipse.jar | sed -e 's/ /:/g')
find -name \*java -exec javac -classpath $classpath '{}' + 
jar cf ../org.eclipse.photran.core.vpg/vpg-eclipse.jar *
popd
#Interferes with feature build
rm -rf vpg-eclipse

# Build the eclipse features
for feature in org.eclipse.photran org.eclipse.photran.intel org.eclipse.photran.xlf
do
  %{eclipse_base}/buildscripts/pdebuild -d "cdt rse" \
    -f $feature -a "-DjavacSource=1.5 -DjavacTarget=1.5" 2>&1 | tee ${feature}.log
done


%install
rm -rf ${RPM_BUILD_ROOT}
for feature in org.eclipse.photran org.eclipse.photran.intel org.eclipse.photran.xlf
do
  install -d -m755 ${RPM_BUILD_ROOT}%{eclipse_base}/dropins/${feature}

  unzip -o -d ${RPM_BUILD_ROOT}%{eclipse_base}/dropins/${feature} \
              build/rpmBuild/${feature}.zip
  mv ${RPM_BUILD_ROOT}%{eclipse_base}/dropins/${feature}/eclipse/* \
     ${RPM_BUILD_ROOT}%{eclipse_base}/dropins/${feature}
  rmdir ${RPM_BUILD_ROOT}%{eclipse_base}/dropins/${feature}/eclipse
done

%if %{gcj_support}
aot-compile-rpm
%endif


%clean 
rm -rf ${RPM_BUILD_ROOT}


%if %{gcj_support}
%post -p %{_bindir}/rebuild-gcj-db

%postun -p %{_bindir}/rebuild-gcj-db
%endif


%files
%defattr(-,root,root,-)
%doc org.eclipse.photran-feature/epl-v10.html
%{eclipse_base}/dropins/org.eclipse.photran
%if %{gcj_support}
%{_libdir}/gcj/%{name}
%endif

%files intel
%defattr(-,root,root,-)
%{eclipse_base}/dropins/org.eclipse.photran.intel

%files xlf
%defattr(-,root,root,-)
%{eclipse_base}/dropins/org.eclipse.photran.xlf


%changelog
* Mon Nov 2 2009 Orion Poplawski <orion@cora.nwra.com> - 4.0.5-0.1.v20090801
- Update to final 4.0.5 cvs
- Drop patch fixed upstream
- Add Requires on eclipse-cdt (bug #532059)
- Cleanup spec file
- Rebuild included jar files

* Tue Apr 7 2009 Orion Poplawski <orion@cora.nwra.com> - 4.0.0-0.6.b5
- Add patch from discussion list to fix outline view

* Mon Mar 23 2009 Alexander Kurtakov <akurtako@redhat.com> 4.0.0-0.5.b5
- Rebuild to not ship p2 content.xml.

* Mon Feb 23 2009 Orion Poplawski <orion@cora.nwra.com> - 4.0.0-0.4.b5
- Update to 4.0.0 Beta 5
- Fix release tag
- Add Intel compiler support package

* Fri Sep 5 2008 Orion Poplawski <orion@cora.nwra.com> - 4.0.0-0.b4.3
- Fix xlf Requires

* Wed Sep 3 2008 Orion Poplawski <orion@cora.nwra.com> - 4.0.0-0.b4.2
- Split out IBM XL Fortran support into sub-package

* Thu Aug 28 2008 Orion Poplawski <orion@cora.nwra.com> - 4.0.0-0.b4.1
- 4.0.0 Beta 4
- Update for building against Eclipse SDK 3.4
- Move everything to %%{_libdir}

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 4.0-1.b3.1
- Autorebuild for GCC 4.3

* Thu Dec 20 2007 - Orion Poplawski <orion@cora.nwr.com> - 4.0-0.b3.1
- One line post/postun script form

* Mon Nov 12 2007 - Orion Poplawski <orion@cora.nwr.com> - 4.0-0.b3
- Initial package
